#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "verzeichnis.h"

int einfuegen(t_verzeichnis *root, char vaterName[64], char neuerSohnName[64])
{
   t_verzeichnis *pVater, *pSohn;

   if( (pVater = suchen(root,vaterName))== NULL)
   	return 0;
   if( (pSohn =(t_verzeichnis *)malloc(sizeof(t_verzeichnis))) == NULL)
   	return 0;

   strncpy(pSohn->name,neuerSohnName,64);
   pSohn->sohn = NULL;
   pSohn->next = pVater->sohn;
   pSohn->vater = pVater;
   pVater->sohn = pSohn;
   return 1;
}

int loeschen(t_verzeichnis *root, char zuLoeschenName[64])
{
	t_verzeichnis *pLoeschen, **ppLoeschverweis;

   pLoeschen = suchen(root,zuLoeschenName);
	if (pLoeschen == NULL || pLoeschen->sohn != NULL) return 0;

   ppLoeschverweis = &(pLoeschen->vater->sohn);

   while( *ppLoeschverweis != pLoeschen)
   	ppLoeschverweis = &((*ppLoeschverweis)->next);
   *ppLoeschverweis = pLoeschen->next;
   free(pLoeschen);
   return 1;
}

t_verzeichnis* suchen(t_verzeichnis *root, char zuSuchenName[64])
{
	t_verzeichnis *pAktSohn, *pGefunden = NULL;
   pAktSohn = root->sohn;
   if( strcmp(zuSuchenName,root->name) == 0)
   	return root;
   while(pAktSohn != NULL && pGefunden == NULL)
   {
   	pGefunden = suchen(pAktSohn,zuSuchenName);
      pAktSohn = pAktSohn->next;
   }
   return pGefunden;
}

void ausgabe(t_verzeichnis *root, int einrueckung)
{
	int i;
   t_verzeichnis *pAktSohn;
	for(i=0; i<einrueckung; ++i)
		printf(" ");
   printf("%s\n",root->name);
      pAktSohn = root->sohn;
   while (pAktSohn != NULL)
   {
    	ausgabe(pAktSohn,einrueckung +2);
    	pAktSohn = pAktSohn->next;
   }
}

